﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Windows.Forms;

namespace WinGridColumnFormulasSolution
{
    public partial class Form1 : Form
    {
        public string _marginFormula = string.Format("( ( ([finCost()]/{0})-sum([FinalCost]) )-sum([CalcMarkup])-1000 )", "{0}");
        public Form1()
        {
            InitializeComponent();
            this.ultraGrid1.DataSource = GridInfo.GetTable();
            this.ultraGrid1.CalcManager = this.ultraCalcManager1;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            // *** added by Jeff
            ultraGrid1.DisplayLayout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;
            ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add("ProdCatID", false, true);
            ultraGrid1.DisplayLayout.Override.AllowRowSummaries = AllowRowSummaries.False;


            var value = 1 - (this.numericUpDown1.Value / 100);
            var band = e.Layout.Bands[0];

            this.ultraGrid1.DisplayLayout.Bands[0].Summaries.Add("finCost", SummaryType.Sum, this.ultraGrid1.DisplayLayout.Bands[0].Columns["FinalCost"]);
            this.ultraGrid1.DisplayLayout.Bands[0].Summaries["finCost"].DisplayFormat = "${0:#,##0}";
            this.ultraGrid1.DisplayLayout.Bands[0].Summaries["finCost"].SummaryDisplayArea = SummaryDisplayAreas.Bottom;

            SummarySettings ss  = band.Summaries.Add("ForcedAdj", string.Format(_marginFormula,value));
            band.Summaries["ForcedAdj"].SummaryDisplayArea = SummaryDisplayAreas.Bottom;
            ss.DisplayFormat = "ForcedAdj: {0}";

            band.Columns["ForcedMarkup"].Formula = "if([RemainingCost] = 0, 0, ([RemainingCost]/[sumRemCost()])*[ForcedAdj()])";
            band.Columns["ForcedMarkup"].Format = "#,###";
            this.ultraGrid1.DisplayLayout.Bands[0].Summaries.Add("sumRemCost", "sum( [RemainingCost] )",
                SummaryPosition.UseSummaryPositionColumn, this.ultraGrid1.DisplayLayout.Bands[0].Columns["RemainingCost"]);
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            this.ultraGrid1.DisplayLayout.Bands[0].Summaries["ForcedAdj"].Formula = string.Format(_marginFormula, 1 - (this.numericUpDown1.Value / 100));
        }
    }
}
